/*******************************************************************************
Copyright © 2024 Sebastian Roith

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

(function(window) {

const TABLES = [
    { "name": "STUNDENPLAN", "primary": ["tag", "stunde"], "table": [
        ["tag", "stunde", "fach", "raum"],
        [4, 4, "Mathematik", "E12"],
        [2, 1, "Mathematik", "E12"],
        [5, 4, "Latein", "E12"],
        [2, 3, "Deutsch", "E12"],
        [1, 6, "Geschichte", "E12"],
        [3, 3, "Religionslehre", "E34"],
        [5, 6, "Physik", "M07"],
        [1, 5, "Englisch", "E12"],
        [5, 5, "Chemie", "M12"],
        [1, 1, "Deutsch", "E12"],
        [3, 4, "Religionslehre", "E34"],
        [3, 6, "Mathematik", "E12"],
        [4, 1, "Informatik", "E40"],
        [3, 1, "Englisch", "E12"],
        [5, 1, "Englisch", "E12"],
        [4, 5, "Kunst", "G077"],
        [1, 3, "Physik", "M07"],
        [1, 2, "Deutsch", "E12"],
        [2, 4, "Latein", "E12"],
        [3, 2, "Biologie", "M12"],
        [2, 5, "Sport", "Turnhalle"],
        [4, 6, "Kunst", "G077"],
        [4, 2, "Informatik", "E40"],
        [5, 3, "Latein", "E12"],
        [2, 2, "Chemie", "M12"],
        [4, 7, "Geschichte", "E12"],
        [5, 2, "Physik", "M07"],
        [4, 3, "Chemie", "M12"],
        [2, 6, "Sport", "Turnhalle"],
        [3, 5, "Mathematik", "E12"],
        [1, 4, "Biologie", "M11"]
    ] }
];

const LEVELS = [
    {
        "task": "<p>Eine Neuntklässlerin hat ihren eigenen Stundenplan als Datenbanktabelle <code>STUNDENPLAN</code> hinterlegt.</p><p>Mache dich zunächst mit dieser Datenbanktabelle vertraut. Schreibe dazu zuerst eine Abfrage, die dir eine der Datenbanktabelle möglichst ähnliche Ergebnistabelle liefert. Führe sie aus und schaue dir die Ergebnistabelle genau an. Fülle dann einen Lückentext richtig aus.</p>",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "and", "max": 0, "fine": 0, "msg": "In dieser Teilaufgabe ist „AND“ noch nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Teilaufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Teilaufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Teilaufgabe ist „ORDER BY“ noch nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "tag", "fine": 1, "msg": "Das erste Attribut muss „tag“ sein" },
            { "type": "attributeName", "index": 1, "value": "stunde", "fine": 1, "msg": "Das zweite Attribut muss „stunde“ sein" },
            { "type": "attributeName", "index": 2, "value": "fach", "fine": 1, "msg": "Das dritte Attribut muss „fach“ sein" },
            { "type": "attributeName", "index": 3, "value": "raum", "fine": 1, "msg": "Das vierte Attribut muss „raum“ sein" },
            { "type": "sameResult", "value": "SELECT * FROM STUNDENPLAN", "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht bestmöglich der Datenbanktabelle…" },
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Fülle die Lücken richtig aus:",
            "choices": [
                { "selectalways": true, "html": "Pro Woche gibt es ", "type": "number", "min": 0, "step": 1, "unit": " Englischstunden.", "accept": "3", "correct": true },
                { "selectalways": true, "html": "Das Klassenzimmer ist wohl der Raum ", "type": "text", "unit": ".", "accept": "E12", "correct": true, "response": "Die meisten Stunden finden im Raum E12 statt. Also scheint das das Klassenzimmer zu sein." },
                { "selectalways": true, "html": "Kürzel (z. B. <em>Sa</em> für Samstag) eines Tages mit Nachmittagsunterricht: ", "type": "text", "accept": "Do", "casesensitive": false, "maxlength": 2, "correct": true, "response": "Nur am vierten Tag (also donnerstags) gibt es eine siebte Stunde." }
            ]
        }
    },
    {
        "task": "<p>Schreibe und teste eine einfache Abfrage, die (in dieser Reihenfolge) liefert, in welcher Stunde und welchem Raum die Neuntklässlerin am Montag welches Fach hat.</p>",
        "code": "SELECT * FROM STUNDENPLAN",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 3, "fine": 1, "msg": "Nur die genannten Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "stunde", "fine": 1, "msg": "Das erste Attribut muss „stunde“ sein" },
            { "type": "attributeName", "index": 1, "value": "raum", "fine": 1, "msg": "Das zweite Attribut muss „raum“ sein" },
            { "type": "attributeName", "index": 2, "value": "fach", "fine": 1, "msg": "Das dritte Attribut muss „fach“ sein" },
            { "type": "sameResult", "value": "SELECT stunde, raum, fach FROM STUNDENPLAN WHERE tag = 1", "fine": 1 },
            { "type": "keyword", "value": "and", "max": 0, "fine": 1, "msg": "Deine Auswahlbedingung ist unnötig kompliziert, „AND“ brauchst du hier nicht" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 1, "msg": "Deine Auswahlbedingung ist unnötig kompliziert, „OR“ brauchst du hier nicht" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 1, "msg": "Deine Auswahlbedingung ist unnötig kompliziert, „NOT“ brauchst du hier nicht" },
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Was ist an der Ergebnistabelle offensichtlich unpraktisch?",
            "singlechoice": true,
            "choices": [
                { "html": "Die Reihenfolge der Datensätze", "correct": true },
                { "html": "Dass dort auch Datensätze zu anderen Wochentagen vorhanden sind" },
                { "html": "Wo der Unterricht stattfindet, ist unklar" },
                { "html": "Die Bezeichnung der Fächer ist nicht aussagekräftig" }
            ]
        }
    },
    {
        "task": "<p>So bringst du die Datensätze in die gewünschte Reihenfolge. Probiere die Abfrage aus und beantworte dann die Frage:</p>",
        "code": "SELECT stunde, raum, fach \n    FROM STUNDENPLAN\n    WHERE tag = 1\n    ORDER BY stunde",
        "readonly": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [],
        "checkTermination": [
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Was dient offenbar der Festlegung der Sortierreihenfolge?",
            "choices": [
                { "html": "Neues Schlüsselwort ", "type": "text", "casesensitive": false, "accept": ["ORDER BY", "BY", "ORDER"], "correct": true },
                { "html": "Die Angabe des Attributs, nach dessen Wert sortiert werden soll", "correct": true },
                { "html": "Eine zusätzliches Auswahlbedingung" },
                { "html": "Ein zusätzliches, in der Ergebnistabelle nicht sichtbares Attribut" }
            ]
        }
    },
    {
        "task": "<p>Eine Sortierung erreichtst du also dadurch, dass du am Ende der Abfrage <code>ORDER BY</code> gefolgt vom Namen des Attributes angibst, nach dem sortiert werden soll. Ob das Attribut tatsächlich in die Ergebnistabelle übernommen wird, ist übrigens unwichtig. Probiere das aus und streiche das Attribut <code>stunde</code> aus der Ergebnistabelle. Alles andere (inklusive der Sortierung) soll gleich bleiben.</p>",
        "code": "SELECT stunde, raum, fach \n    FROM STUNDENPLAN\n    WHERE tag = 1\n    ORDER BY stunde",
        "keepCode": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 2, "fine": 1, "msg": "Nur noch „raum“ und „fach“ sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "raum", "fine": 1, "msg": "Das erste Attribut muss „raum“ sein" },
            { "type": "attributeName", "index": 1, "value": "fach", "fine": 1, "msg": "Das zweite Attribut muss „fach“ sein" },
            { "type": "keyword", "value": "order", "min": 1, "max": 1, "fine": 1, "msg": "Lass die Festlegung der Sortierreihenfolge stehen!" },
            { "type": "compareQuery", "value": "WHERE tag = 1 ORDER", "substring": true, "fine": 1, "msg": "Wozu hast du die Auswahlbedingung verändert?" },
            { "type": "sameResult", "value": "SELECT raum, fach FROM STUNDENPLAN WHERE tag = 1 ORDER BY stunde", "checkOrder": true, "fine": 1 },
            { "type": "accept", "unlock": true }
        ],
    },
    {
        "task": "<p>Schreibe und teste nun eine möglichst einfache Abfrage, die dir nur eine (alphabetisch) sortierte Liste aller Fächer liefert. Jedes Fach soll dabei nur einmal aufgeführt sein.</p>",
        "code": "SELECT raum, fach \n    FROM STUNDENPLAN\n    WHERE tag = 1\n    ORDER BY stunde",
        "keepCode": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 1, "fine": 1, "msg": "Nur Werte des Attributes „fach“ sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "fach", "fine": 1, "msg": "Das einzige Attribut muss „fach“ sein" },
            { "type": "keyword", "value": "order", "min": 1, "max": 1, "fine": 1, "msg": "Die Angabe der Sortierreihenfolge fehlt" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 1, "msg": "Du brauchst keine Auswahlbedingung, lasse sie und „WHERE“ also einfach weg" },
            { "type": "keyword", "value": "distinct", "min": 1, "max": 1, "fine": 1, "msg": "Nutze „SELECT DISTINCT“, damit kein Datensatz doppelt vorkommt" },
            { "type": "sameResult", "value": "SELECT DISTINCT fach FROM STUNDENPLAN ORDER BY fach", "checkOrder": true, "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Indem du bei der Festlegung der Sortierreihenfolge <code>DESC</code> für <em>descending</em> (also <em>absteigend</em>) hinter den Attributnamen schreibst, kannst du die Sortierreihenfolge umkehren. Probiere das gleich aus, indem du diese Abfrage nur entsprechend minimal veränderst und dann testest.",
        "code": "SELECT DISTINCT fach \nFROM STUNDENPLAN \nORDER BY fach",
        "keepCode": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "compareQuery", "value": "SELECT DISTINCT fach FROM STUNDENPLAN ORDER BY fach DESC", "fine": 1, "msg": "Ergänze nur „DESC“ am Ende und ändere sonst nichts" },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Wenn explizit angeben willst, dass du nicht die absteigende, sondern die normale <em>aufsteigende</em> Sortierung willst, kannst du das mit dem Schlüsselwort <code>ASC</code> für <em>ascending</em> statt dem Schlüsselwort <code>DESC</code> machen. Probiere auch diese minimale Änderung aus.",
        "code": "SELECT DISTINCT fach \nFROM STUNDENPLAN \nORDER BY fach DESC",
        "keepCode": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "compareQuery", "value": "SELECT DISTINCT fach FROM STUNDENPLAN ORDER BY fach ASC", "fine": 1, "msg": "Ersetze nur „DESC“ durch „ASC“" },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Jetzt können wir auch die gesamte Tabelle sinnvoll sortieren: Die Ergebnistabelle soll alle kompletten Datensätze der Datenbanktabelle enthalten. Allerdings sortiert nach Stunde. Führe eine entsprechende, möglichst einfache Abfrage aus!",
        "code": "SELECT DISTINCT fach \nFROM STUNDENPLAN \nORDER BY fach ASC",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "tag", "fine": 1, "msg": "Das erste Attribut muss „tag“ sein" },
            { "type": "attributeName", "index": 1, "value": "stunde", "fine": 1, "msg": "Das zweite Attribut muss „stunde“ sein" },
            { "type": "attributeName", "index": 2, "value": "fach", "fine": 1, "msg": "Das dritte Attribut muss „fach“ sein" },
            { "type": "attributeName", "index": 3, "value": "raum", "fine": 1, "msg": "Das vierte Attribut muss „raum“ sein" },
            { "type": "keyword", "value": "order", "min": 1, "max": 1, "fine": 1, "msg": "Die Angabe der Sortierreihenfolge fehlt" },
            { "type": "keyword", "value": "desc", "max": 0, "fine": 0, "msg": "Wenn nicht explizit absteigende Sortierung gefordert wird, ist „aufsteigend“ gemeint" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 1, "msg": "Du brauchst keine Auswahlbedingung, lasse sie und „WHERE“ also einfach weg" },
            { "type": "keyword", "value": "distinct", "min": 0, "max": 0, "fine": 1, "msg": "Wozu „DISTINCT“? Weil der komplette Primärschlüssel in der Ergebnistabelle steht, bewirkt das hier nichts" },
            { "type": "sameResult", "value": "SELECT * FROM STUNDENPLAN ORDER BY stunde", "checkOrder": true, "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht den Anforderungen…" },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Nunja, so wirklich sinnvoll ist diese Sortierung nicht. Vielleicht sortieren wir besser nach Wochentag? Führe eine entsprechende, möglichst einfache Abfrage aus!",
        "code": "SELECT * \nFROM STUNDENPLAN \nORDER BY stunde",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "tag", "fine": 1, "msg": "Das erste Attribut muss „tag“ sein" },
            { "type": "attributeName", "index": 1, "value": "stunde", "fine": 1, "msg": "Das zweite Attribut muss „stunde“ sein" },
            { "type": "attributeName", "index": 2, "value": "fach", "fine": 1, "msg": "Das dritte Attribut muss „fach“ sein" },
            { "type": "attributeName", "index": 3, "value": "raum", "fine": 1, "msg": "Das vierte Attribut muss „raum“ sein" },
            { "type": "keyword", "value": "order", "min": 1, "max": 1, "fine": 1, "msg": "Die Angabe der Sortierreihenfolge fehlt" },
            { "type": "keyword", "value": "desc", "max": 0, "fine": 0, "msg": "Wenn nicht explizit absteigende Sortierung gefordert wird, ist „aufsteigend“ gemeint" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 1, "msg": "Du brauchst keine Auswahlbedingung, lasse sie und „WHERE“ also einfach weg" },
            { "type": "keyword", "value": "distinct", "min": 0, "max": 0, "fine": 1, "msg": "Wozu „DISTINCT“? Weil der komplette Primärschlüssel in der Ergebnistabelle steht, bewirkt das hier nichts" },
            { "type": "sameResult", "value": "SELECT * FROM STUNDENPLAN ORDER BY tag", "checkOrder": true, "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht den Anforderungen…" },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "<p>Was wir eigentlich bräuchten, ist eine Sortierung vorrangig nach Wochentag und, wo der Wochentag gleich ist, nach Stunde. Aber das geht problemlos:</p><p>Nach <code>ORDER BY</code> können mehrere Attributnamen aufgelistet werden, wobei zwischen zwei Attributnamen ein Komma muss. Dann wird vorrangig nach den Werten des zuerst angegebenen Attributes sortiert. Nachrangig, also wenn die Werte zum zuerst genannten Attribut identisch sind, nach den Werten des als zweites angebenen Attributes. Noch nachrangiger, also nur, wenn auch die Werte zum zweiten Attribut gleich sind, nach den Werten zum als drittes angegebenen Attribut. Und so weiter.</p><p>Schreibe nun eine möglichst einfache Abfrage, die die komplette Datensätze der Datenbanktabelle wochentagweise sortiert nach Stunde enthält.</p>",
        "code": "SELECT * \nFROM STUNDENPLAN \nORDER BY tag",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "tag", "fine": 1, "msg": "Das erste Attribut muss „tag“ sein" },
            { "type": "attributeName", "index": 1, "value": "stunde", "fine": 1, "msg": "Das zweite Attribut muss „stunde“ sein" },
            { "type": "attributeName", "index": 2, "value": "fach", "fine": 1, "msg": "Das dritte Attribut muss „fach“ sein" },
            { "type": "attributeName", "index": 3, "value": "raum", "fine": 1, "msg": "Das vierte Attribut muss „raum“ sein" },
            { "type": "keyword", "value": "order", "min": 1, "max": 1, "fine": 1, "msg": "Die Angabe der Sortierreihenfolge fehlt" },
            { "type": "keyword", "value": "desc", "max": 0, "fine": 0, "msg": "Wenn nicht explizit absteigende Sortierung gefordert wird, ist „aufsteigend“ gemeint" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 1, "msg": "Du brauchst keine Auswahlbedingung, lasse sie und „WHERE“ also einfach weg" },
            { "type": "keyword", "value": "distinct", "min": 0, "max": 0, "fine": 1, "msg": "Wozu „DISTINCT“? Weil der komplette Primärschlüssel in der Ergebnistabelle steht, bewirkt das hier nichts" },
            { "type": "sameResult", "value": "SELECT * FROM STUNDENPLAN ORDER BY tag, stunde", "checkOrder": true, "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht den Anforderungen…" },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "<p><code>ASC</code> und <code>DESC</code> beziehen sich immer nur auf das eine Attribut, hinter dem sie stehen. Und diese Schlüsselwörter kommen noch vor dem Komma.</p><p>Führe nun eine möglichst einfache Abfrage aus, die (in dieser Reihenfolge) nur Wochentag, Stunde und Fach liefert. Und zwar zuerst für Freitag, dann für Donnerstag, dann für Mittwoch, dann für Dienstag und zuletzt für Montag. Jeweils aufsteigend nach Stunde sortiert.</p>",
        "code": "SELECT * \nFROM STUNDENPLAN \nORDER BY tag, stunde",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 3, "fine": 1, "msg": "Nur die geforderten Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "tag", "fine": 1, "msg": "Das erste Attribut muss „tag“ sein" },
            { "type": "attributeName", "index": 1, "value": "stunde", "fine": 1, "msg": "Das zweite Attribut muss „stunde“ sein" },
            { "type": "attributeName", "index": 2, "value": "fach", "fine": 1, "msg": "Das dritte Attribut muss „fach“ sein" },
            { "type": "keyword", "value": "order", "min": 1, "max": 1, "fine": 1, "msg": "Die Angabe der Sortierreihenfolge fehlt" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 1, "msg": "Du brauchst keine Auswahlbedingung, lasse sie und „WHERE“ also einfach weg" },
            { "type": "keyword", "value": "distinct", "min": 0, "max": 0, "fine": 1, "msg": "Wozu „DISTINCT“? Weil der komplette Primärschlüssel in der Ergebnistabelle steht, bewirkt das hier nichts" },
            { "type": "sameResult", "value": "SELECT tag, stunde, fach FROM STUNDENPLAN ORDER BY tag DESC, stunde", "checkOrder": true, "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht den Anforderungen…" },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Nur zum Spaß: Ändere die Abfrage so ab, dass auch die Stunden falsch herum aufgelistet werden. Also zuerst ggf. die 7. Stunde, dann die 6. Stunde, die 5. Stunde, …",
        "code": "SELECT tag,  \nFROM STUNDENPLAN \nORDER BY tag DESC, stunde",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 3, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "tag", "fine": 1, "msg": "Das erste Attribut muss „tag“ sein" },
            { "type": "attributeName", "index": 1, "value": "stunde", "fine": 1, "msg": "Das zweite Attribut muss „stunde“ sein" },
            { "type": "attributeName", "index": 2, "value": "fach", "fine": 1, "msg": "Das dritte Attribut muss „fach“ sein" },
            { "type": "keyword", "value": "order", "min": 1, "max": 1, "fine": 1, "msg": "Die Angabe der Sortierreihenfolge fehlt" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 1, "msg": "Du brauchst keine Auswahlbedingung, lasse sie und „WHERE“ also einfach weg" },
            { "type": "keyword", "value": "distinct", "min": 0, "max": 0, "fine": 1, "msg": "Wozu „DISTINCT“? Weil der komplette Primärschlüssel in der Ergebnistabelle steht, bewirkt das hier nichts" },
            { "type": "sameResult", "value": "SELECT tag, stunde, fach FROM STUNDENPLAN ORDER BY tag DESC, stunde DESC", "checkOrder": true, "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht den Anforderungen…" },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Schaue dir nun diese SQL-Abfrage an (zunächst ohne sie auszuprobieren!) und beantworte die Frage.",
        "code": "SELECT tag, stunde, fach \nFROM STUNDENPLAN \nORDER BY tag, stunde DESC",
        "readonly": true,
        "tables": TABLES,
        "locked": false,
        "checkCode": [
            { "type": "accept", "accept": false, "fine": 1, "msg": "Du sollst die Abfrage noch nicht ausprobieren!" }
        ],
        "checkTermination": [],
        "questionWrongFine": 1,
        "question": {
            "html": "Wie wird die Ergebnistabelle sortiert?",
            "keepOrder": true,
            "response": "Beachte: <code>DESC</code> bezieht sich nur auf das direkt davor angegebene Attribut.",
            "choices": [
                { "html": "Vorrangig wird <em>aufsteigend</em> nach Werten des Attributs ", "type": "text", "accept": "tag", "unit": " sortiert.", "correct": true },
                { "html": "Vorrangig wird <em>abteigend</em> nach Werten des Attributs ", "type": "text", "accept": "tag", "unit": " sortiert."},
                { "html": "Nachrangig wird <em>aufsteigend</em> nach Werten des Attributs ", "type": "text", "accept": "stunde", "unit": " sortiert." },
                { "html": "Nachrangig wird <em>absteigend</em> nach Werten des Attributs ", "type": "text", "accept": "stunde", "unit": " sortiert.", "correct": true },
                { "html": "Die Sortierreihenfolge ist nicht eindeutig." }
            ]
        }
    },
    {
        "task": "Weil sich <code>DESC</code> nur auf <code>stunde</code> bezieht, wird <em>aufsteigend</em> nach <code>tag</code> sortiert. Überprüfe das, indem du die Abfrage nun ausführst!",
        "code": "SELECT tag, stunde, fach \nFROM STUNDENPLAN \nORDER BY tag, stunde DESC",
        "readonly": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [],
        "checkTermination": [
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Zum Abschluss noch eine schwerere Abfrage: Gesucht sind Wochentag, Stunde, Raumnummer und Fach aller MINT-Fächer (Mathematik, Informatik, Biologie, Chemie und Physik). Sortiere absteigend nach Raumnummer. Bei gleicher Raumnummer soll alphabetisch nach Fach sortiert werden. Sind Raumnummer und Fach gleich, soll zuerst der spätere Wochentag aufgeführt werden. Und wenn das immer noch nicht eindeutig ist, zuerst die frühere Stunde.",
        "keepCode": true,
        "code": "SELECT tag, stunde, fach \nFROM STUNDENPLAN \nORDER BY tag, stunde DESC",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "tag", "fine": 1, "msg": "Das erste Attribut muss „wochentag“ sein" },
            { "type": "attributeName", "index": 1, "value": "stunde", "fine": 1, "msg": "Das zweite Attribut muss „stunde“ sein" },
            { "type": "attributeName", "index": 2, "value": "raum", "fine": 1, "msg": "Das dritte Attribut muss „raum“ sein" },
            { "type": "attributeName", "index": 3, "value": "fach", "fine": 1, "msg": "Das vierte Attribut muss „fach“ sein" },
            { "type": "keyword", "value": "order", "min": 1, "max": 1, "fine": 1, "msg": "Die Angabe der Sortierreihenfolge fehlt" },
            { "type": "keyword", "value": "distinct", "min": 0, "max": 0, "fine": 1, "msg": "Wozu „DISTINCT“? Weil der komplette Primärschlüssel in der Ergebnistabelle steht, bewirkt das hier nichts" },
            { "type": "sameResult", "value": "SELECT tag, stunde, raum, fach FROM STUNDENPLAN WHERE fach = 'Mathematik' OR fach = 'Informatik' OR fach = 'Biologie' OR fach = 'Chemie' OR fach = 'Physik' ORDER BY raum DESC, fach, tag DESC, stunde", "checkOrder": true, "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    }
];

window.sqlCodingTask = {
    levels: LEVELS
};
})(window);
